; ***** BEGIN LICENSE BLOCK *****
; * Copyright (C) 2007  Stanislav Ievlev <inger@altlinux.org>
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; *
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; * GNU General Public License for more details.
; *
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
; ***** END LICENSE BLOCK *****

(document:surround "/std/frame")
(document:envelop with-translation _ "alterator-install2")

(define general-next (make-cell #f))
(define general-back (make-cell #f))

(define tcp-next (make-cell #f))
(define tcp-back (make-cell #f))
(define tcp-auto-save (make-cell #f))
(define general-auto-save (make-cell #f))

(define has-ifaces (pair? (woo-list-names "/net-eth")))

(define (cell-run cell)
 (let ((cell (cell-ref cell)))
   (and (procedure? cell) (cell))))

(define (cell-list-run . cell-list)
  (any (lambda(x) (let ((value (cell-run x)))
                    (and (eq? value 'cancel) 'cancel)))
       cell-list))

(tabbox
 (when selected (cell-run tcp-auto-save)
		(cell-run general-auto-save)
		(net-general loaded))
 (and has-ifaces
     (tab (_ "IP interfaces")
          (document:id net-eth
                   (document:subdocument '/net-eth
                                         'frame:next tcp-next
                                         'frame:back tcp-back
                                         'frame:auto-save tcp-auto-save))))

 (tab (_ "General Network Settings")
      (document:id net-general
                   (document:subdocument '/net-general
                                         'frame:next general-next
                                         'frame:back general-back
					 'frame:auto-save general-auto-save))) )

(document:root (when loaded (net-general loaded)))

(define (network-next)
 (if has-ifaces
     (cell-list-run general-next tcp-next)
     (cell-list-run general-next)))

(frame:on-next network-next)
(frame:on-back network-next)
